import java.util.Scanner;
/**
 * Menu: Encapsulates user input via System.in ensuring
 * that input is what is expected.
 * @author Jered
 */
public class Menu {
	private static Scanner input = new Scanner(System.in);
	private static boolean go = true;
	
	/**
	 * MenuString: this method takes user input via the
	 * Scanner object, checks that it is Y, y, N, or n
	 * then returns the input as String.
	 * A customizable message can be sent to the system for display.
	 * @param message
	 * @return String
	 */
	public String MenuString(String message){
		String localMessage = message;//assign the message to a local variable
		String localInput = "";//Initialize the localInput
		Scanner throwAway = new Scanner(System.in);//used to clear the class Scanner object
		input = throwAway;
		
		//Ask for user input
		System.out.println(localMessage + " please type Y or N: ");
		while(go){//while the application is active
			//gather user input
			localInput = input.nextLine();
			
			//if the user input is what is expected
			if((localInput.equalsIgnoreCase("N"))||localInput.equalsIgnoreCase("Y")){
				if(localInput.equalsIgnoreCase("N")){//and the user input is equal to N
					go = false;//stop the application
				}else{//if the user input is equal to Y then continue the application
					break;//break out of this while loop and method
				}//end inner ifElse
			}else{//if the input is not what is expected
				System.out.println("\nPlease type Y or N: ");//clarify input
				continue;//loop method
			}//end outer ifElse
		}//end while loop
		return localInput;
	}//end MenuString()
	
	/**
	 * MenuString: this method takes user input via the
	 * Scanner object, checks that it is Y, y, N, or n
	 * then returns the input as String.
	 * @return String
	 */
	public String MenuString(){
		String localInput = "";//Initialize the localInput
		Scanner throwAway = new Scanner(System.in);//used to clear the class Scanner object
		input = throwAway;
		
		//Ask for user input
		System.out.println("Please type Y or N: ");
		while(go){//while the application is active
			//gather user input
			localInput = input.nextLine();
			
			//if the user input is what is expected
			if((localInput.equalsIgnoreCase("N"))||localInput.equalsIgnoreCase("Y")){
				if(localInput.equalsIgnoreCase("N")){//and the user input is equal to N
					go = false;//stop the application
				}else{//if the user input is equal to Y then continue the application
					break;//break out of this while loop and method
				}//end inner ifElse
			}else{//if the input is not what is expected
				System.out.println("\nPlease type Y or N: ");//clarify input
				continue;//loop method
			}//end outer ifElse
		}//end while loop
		return localInput;
	}//end MenuString()
	
	/**
	 * MenuDouble: this method takes user input via the
	 * Scanner object, checks that it is what is expected,
	 * then returns the input as double.
	 * @return double
	 */
	public double MenuDouble(){
		//Initialize localInput
		double localInput = 0;
		//while the application is running
		while(go){
			if(input.hasNextDouble()){//if the input is what is expected
				localInput = input.nextDouble();//gather input
				break;//end loop
			}else{//if the input is not what is expected
				System.out.println("\nPlease type a number: ");//clarify input
				Scanner throwAway = new Scanner(System.in);//instantiate a new Scanner object
				input = throwAway;//clear the class scanner object
			}//end ifEse
		}//end while loop
		return localInput;//return the user's input
	}//end MenuDouble()
	
	/**
	 * MenuInt: this method takes user input via the
	 * Scanner object, checks that it is what is expected,
	 * then returns the input as int.
	 * @return int
	 */
	public int MenuInt(){
		//Initialize localInput
		int localInput = 0;
		//while the application is running
		while(go){
			if(input.hasNextInt()){//if the input is what is expected
				localInput = input.nextInt();//gather input
				break;//end loop
			}else{//if the input is not what is expected
				System.out.println("\nPlease type a whole number: ");//clarify input
				Scanner throwAway = new Scanner(System.in);//instantiate a new Scanner object
				input = throwAway;//clear the class scanner object
			}//end ifEse
		}//end while loop
		return localInput;//return the user's input
	}//end MenuDouble()
}
